config/routes.rb
Rails.application.routes.draw do
  get 'user/index'

  devise_for :users
  
  resources :posts do
  	resources :comments
  end
  
  get 'home/index'


  root "home#index"

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :post
  acts_as_paranoid
end

app/models/post.rb
class Post < ApplicationRecord
  acts_as_paranoid
	has_many :comments, dependent: :destroy

	validates :title, presence: true
	validates :body,  presence: true

	has_attached_file :avatar, styles: { thumb: "400x400>" }
  	validates_attachment_content_type :avatar, content_type: /\Aimage\/.*\z/

  	scope :search, ->(query) { where("title like ?", "%#{query}%") }


  	def self.to_csv(options = {})
  		CSV.generate(options) do |csv|
  			csv << column_names
  			all.each do |post|
  				csv << post.attributes.values_at(*column_names)
  			end
  		end
  	end
end

app/models/user.rb
class User < ApplicationRecord
  #acts_as_paranoid
  enum role: [:normal_user, :admin]

  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  include Pundit
  protect_from_forgery with: :exception

  rescue_from Pundit::NotAuthorizedError, with: :user_not_authorized

  private

    def user_not_authorized
      flash[:notice] = "você não tem permissão para executar essa ação."
      redirect_to(request.referrer || root_path)
    end

end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  
  before_action :authenticate_user!

    def index
      @comments = Comment.all.order('created_at DESC')
    end
  
    def create
      @post = Post.find(params[:post_id])
      @comment = @post.comments.create(params[:comment].permit(:name, :body))

      redirect_to post_path(@post)
    end

    def destroy
      
      @post = Post.find(params[:post_id])
      @comment = @post.comments.with_deleted.find(params[:id])
      

      if params[:type] == 'normal'
        @comment.destroy
      elsif params[:type] == 'forever'
        @comment.really_destroy!
      elsif params[:type] == 'undelete'
      @comment.restore
    end

    redirect_to post_path(@post)
    end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
  end
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :set_post, only: [:show, :edit, :update]
  before_action :authenticate_user!
  # GET /posts
  # GET /posts.json
  def index
    if params[:search]
      @posts = Post.search(params[:search])
      respond_to do |format|
        format.html
        format.csv { send_data @posts.to_csv}
        format.xls
      end
    else
      @posts = Post.all.order('created_at DESC')
      respond_to do |format|
        format.html
        format.csv { send_data @posts.to_csv}
        format.xls 
        
      end
    end
  end

  # GET /posts/1
  # GET /posts/1.json
  def show
    
  end

  # GET /posts/new
  def new
    @post = Post.new
  end

  # GET /posts/1/edit
  def edit
    
  end

  # POST /posts
  # POST /posts.json
  def create
    @post = Post.new(post_params)

    if @post.save
      redirect_to @post
    else
      render 'new'
    end
  end

  # PATCH/PUT /posts/1
  # PATCH/PUT /posts/1.json
  def update
    
    if @post.update(params[:post].permit(:title, :body, :avatar))
      redirect_to @post
    else
      render 'edit'
    end
  end

  # DELETE /posts/1
  # DELETE /posts/1.json
  def destroy
      @post = Post.with_deleted.find(params[:id])
    if params[:type] == 'normal'
      @post.destroy
    elsif params[:type] == 'forever'
      @post.really_destroy!
    elsif params[:type] == 'undelete'
      @post.restore
    end

    redirect_to posts_path
  end

  

  private
    def set_post
      @post = Post.find(params[:id])
    end

    def post_params
      params.require(:post).permit(:title, :body, :avatar)
    end
end

app/controllers/user_controller.rb
class UserController < ApplicationController
  before_action :authenticate_user!

  def index
  	@users = User.all
  	authorize @users
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/helpers/user_helper.rb
module UserHelper
end

app/views/comments/_comment.html.erb
<div class="comment clearfix">
	<div class="comment_content">
		<p class="comment_name"><strong><%= comment.name %></strong></p>
		<p class="comment_body"><%= comment.body %></p>
		<p class="comment_time"><%= time_ago_in_words(comment.created_at) %> Ago</p>
	</div>

	<% if user_signed_in? %>
		<% if current_user.admin? %> 
	<p><%= link_to 'Delete', [comment.post, comment], method: :delete, class: "btn btn-danger mb-2",
		data: { confirm: 'Are you sure?' } %></p>
		<% end %>
 	<% end %> 
 	<br><hr>	
</div>

app/views/comments/_form.html.erb
<%= form_for([@post, @post.comments.build]) do |f| %>

<div class="form-group">
  <%= f.label :name, :class => 'control-label col-lg-2' %>
  <div class="col-lg-10" id="campos_text_field">
  	<%= f.text_field :name, :class => 'form-control' %>
  </div>
  <%=f.error_span(:title) %>
</div>
  

<div class="form-group">
  <%= f.label :body, :class => 'control-label col-lg-2' %>
  <div class="col-lg-10" id="campos_text_area">
  	<%= f.text_area :body, :class => 'form-control' %>
  </div>
  <%=f.error_span(:title) %>
</div>

  <div class="form-group">
    <div class="col-lg-offset-2 col-lg-10">
      <%= f.submit nil, :class => 'btn btn-primary' %>
    </div>
  </div>


<% end %>

app/views/comments/edit.html.erb
<%- model_class = Comment -%>
<div class="page-header">
  <h1><%=t '.title', :default => [:'helpers.titles.edit', 'Edit %{model}'], :model => model_class.model_name.human.titleize %></h1>
</div>
<%= render :partial => 'form' %>

app/views/comments/index.html.erb
<%- model_class = Comment -%>
<div class="page-header">
  <h1><%=t '.title', :default => model_class.model_name.human.pluralize.titleize %></h1>
</div>
<table class="table table-striped">
  <thead>
    <tr>
      <th><%= model_class.human_attribute_name(:id) %></th>
      <th><%= model_class.human_attribute_name(:name) %></th>
      <th><%= model_class.human_attribute_name(:body) %></th>
      <th><%= model_class.human_attribute_name(:post_id) %></th>
      <th><%= model_class.human_attribute_name(:created_at) %></th>
      <th><%=t '.actions', :default => t("helpers.actions") %></th>
    </tr>
  </thead>
  <tbody>
    <% @comments.each do |comment| %>
      <tr>
        <td><%= link_to comment.id, comment_path(comment) %></td>
        <td><%= comment.name %></td>
        <td><%= comment.body %></td>
        <td><%= comment.post_id %></td>
        <td><%=l comment.created_at %></td>
        <td>
          <%= link_to t('.show', :default => t("helpers.links.show")),
                      comment_path(comment), :class => 'btn btn-default btn-xs' %>
          <%= link_to t('.edit', :default => t("helpers.links.edit")),
                      edit_comment_path(comment), :class => 'btn btn-default btn-xs' %>
          <%= link_to t('.destroy', :default => t("helpers.links.destroy")),
                      comment_path(comment),
                      :method => :delete,
                      :data => { :confirm => t('.confirm', :default => t("helpers.links.confirm", :default => 'Are you sure?')) },
                      :class => 'btn btn-xs btn-danger' %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

<%= link_to t('.new', :default => t("helpers.links.new")),
            new_comment_path,
            :class => 'btn btn-primary' %>

app/views/comments/new.html.erb
<%- model_class = Comment -%>
<div class="page-header">
  <h1><%=t '.title', :default => [:'helpers.titles.new', 'New %{model}'], :model => model_class.model_name.human.titleize %></h1>
</div>
<%= render :partial => 'form' %>

app/views/comments/show.html.erb
<%- model_class = Comment -%>
<div class="page-header">
  <h1><%=t '.title', :default => model_class.model_name.human.titleize %></h1>
</div>

<dl class="dl-horizontal">
  <dt><strong><%= model_class.human_attribute_name(:name) %>:</strong></dt>
  <dd><%= @comment.name %></dd>
  <dt><strong><%= model_class.human_attribute_name(:body) %>:</strong></dt>
  <dd><%= @comment.body %></dd>
  <dt><strong><%= model_class.human_attribute_name(:post_id) %>:</strong></dt>
  <dd><%= @comment.post_id %></dd>
</dl>

<%= link_to t('.back', :default => t("helpers.links.back")),
              comments_path, :class => 'btn btn-default'  %>
<%= link_to t('.edit', :default => t("helpers.links.edit")),
              edit_comment_path(@comment), :class => 'btn btn-default' %>
<%= link_to t('.destroy', :default => t("helpers.links.destroy")),
              comment_path(@comment),
              :method => 'delete',
              :data => { :confirm => t('.confirm', :default => t("helpers.links.confirm", :default => 'Are you sure?')) },
              :class => 'btn btn-danger' %>

app/views/home/index.html.erb
<h1>Blog do Felix</h1>
	
	<% if user_signed_in? %>
		<p>Olá <%= current_user.email %>, meu nome é Luiz Felix, seja muito bem vindo ao meu blog.</p>		
	<% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html lang="pt-BR">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=Edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title><%= content_for?(:title) ? yield(:title) : "MyBlog" %></title>


    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

    <link rel="stylesheet" href="https://www.w3schools.com/w3css/4/w3.css">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Raleway">

    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag "application", :media => "all" %>

    <%= javascript_include_tag "application" %>

  </head>
  <body>

    <div class="navbar navbar-default navbar-fixed-top">
      <div class="container">
        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-responsive-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <a class="navbar-brand" href="/">MyBlog</a>
        <div class="navbar-collapse collapse navbar-responsive-collapse">
          <ul class="nav navbar-nav">
            <li id="opcoes"><%= link_to "Posts", "/posts"  %></li>
              
              
            <% if user_signed_in? %>
              <% if current_user.admin? %>        
              <li><%= link_to "User" , "/user/index"  %></li>
              <% end %>
              <li><%= link_to 'Sair =>', destroy_user_session_path, method: :delete %></li>
              
            <% else %>
              <li><%= link_to 'Cadastrar usuario ', new_user_registration_path %></li>
              <li><%= link_to 'Login ', new_user_session_path %></li>
            <% end %>
          </ul>
        </div>
      </div>
    </div>

    <div class="container">
      <div class="row">
        <div class="col-lg-9">
          <%= bootstrap_flash %>
          <%= yield %>
        </div>
      </div>

      <footer>
        <p>&copy; Company 2018</p>
      </footer>

    </div> 

  </body>
</html>

app/views/posts/_form.html.erb
<%= form_for @post, html: { multipart: true } do |f| %>
  <% if @post.errors.any? %>
    <div id="errors">
      <h2><%= pluralize(@post.errors.count, "error") %> prevented this post from saving:</h2>
      <ul>
        <% @post.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">    
    <%= f.label :title, :class => 'control-label col-lg-2' %>
    <div class="col-lg-10">
      <%= f.text_field :title, :class => 'form-control' %>    
    </div>
    <%=f.error_span(:title) %>
    <br>
  </div>


  <div class="form-group">    
    <%= f.label :bodi, :class => 'control-label col-lg-2' %>
    <div class="col-lg-10">
      <%= f.text_area :body, :class => 'form-control' %>    
    </div>
    <%=f.error_span(:body) %>
  </div> 

  <div class="field">
    <%= f.label :avatar %>
    <%= f.file_field :avatar %>
  </div>

  <div class="form-group">
    <div class="col-lg-offset-2 col-lg-10">
      <%= f.submit nil, :class => 'btn btn-primary' %>
      <%= link_to t('.cancel', :default => t("helpers.links.cancel")),
                posts_path, :class => 'btn btn-default' %>
    </div>
  </div>
<% end %>

app/views/posts/edit.html.erb
<%- model_class = Post -%>
<div class="page-header">
  <h1><%=t '.title', :default => [:'helpers.titles.edit', 'Edit %{model}'], :model => model_class.model_name.human.titleize %></h1>
</div>
<%= render :partial => 'form' %>

app/views/posts/index.html.erb
<body class="w3-light-grey" >
	<div id="all">
<h1>Posts</h1>

<%= form_tag(posts_path, method: :get) do %>
  <div class="col-lg-4">
	<%= text_field_tag 'search', nil, placeholder: 'Enter search term...', :class => 'form-control' %>
  </div>
	<%= submit_tag "Search", :id => "button_search", :class => 'btn btn-default'%>
<% end %><br>


<div class="w3-card-4 w3-margin w3-white">
<% @posts.each do |post| %>


<div class="w3-col 18 s12">
  <div class="w3-card-4 w3-margin w3-white thumbnail">
    <img ><%= image_tag post.avatar.url(:thumb) %></img>
    <div class="w3-container">
      <h3><b><%= link_to post.title, post %> </b></h3>
      <h5><span class="w3-opacity"><%= time_ago_in_words(post.created_at) %></span></h5>
    </div>

    <div class="w3-container">
      <p><%= post.body %></p>
      <div class="w3-row">
        <div class="w3-col m8 s12">
          <p><button class="w3-button w3-padding-large w3-white w3-border"><b><%= link_to "READ MORE »", post %></b></button></p>
        </div>
        <div class="w3-col m4 w3-hide-small">
          <p><span class="w3-padding-large w3-right"><b>Comments</b> 
          		<span class="w3-tag"><%= post.comments.count %></span>
          	</span></p>
        </div>
      </div>
    </div>

  </div>
</div><% end %>

</div><!--</div>--><br><br>

<div class="w3-col 22 s22">
	<% if current_user.admin? %>

		<%= link_to t('.new', :default => t("helpers.links.new")), new_post_path, :id => 'buttons', :class => 'btn btn-primary' %>
		<br>
		<p>
			<h4>Download:</h4>
			<%= link_to 'CSV', posts_path(format: "csv"), :id => 'buttons', :class => 'btn btn-default' %>
			<%= link_to 'Excel', posts_path(format: "xls"), :id => 'buttons', :class => 'btn btn-default' %>
		</p><hr><hr><br>



	<h2>Deleted Posts: </h2> 
	</div>
	<% @posts.only_deleted.each do |post| %>
	<div class="w3-card-4 w3-margin w3-white">

		<div class="w3-col 18 s12">
  
  			<div class="w3-card-4 w3-margin w3-white">
    			<img ><%= image_tag post.avatar.url(:thumb) %></img>
    			<div class="w3-container">
      				<h3><b><%= link_to post.title, post %> </b></h3>
      				<h5><span class="w3-opacity"><%= time_ago_in_words(post.created_at) %></span></h5>
    			</div>

    			<div class="w3-container">
      				<p><%= post.body %></p>
      				<div class="w3-row">
        				<div class="w3-col m8 s12">
          					<p><button class="w3-button w3-padding-large w3-white w3-border"><b><%= link_to "READ MORE »", post %></b></button></p>
        				</div>
        				<div class="w3-col m4 w3-hide-small">
          				<p><span class="w3-padding-large w3-right"><b>Comments</b> 
          					<span class="w3-tag"><%= post.comments.count %></span>
          				</span></p>
        				</div>
      				</div>
    			</div>
	  		</div>
		</div>
	</div>
	
	<%= link_to 'Undelete', post_path(post.id, type: :undelete), method: :delete, :id => 'buttons', :class => 'btn btn-success' %>
 	<%= link_to 'Really delete', post_path(post.id, type: :forever), method: :delete, :id => 'buttons', :class => 'btn btn-danger' %>
 	
  			
		<% end %>
	<% end %>

<br><br><br><br>

<h3><%= link_to '<==Home', root_path, :id => 'buttons'%></h3>
</div>
</body>

app/views/posts/index.xls.erb
<table border="1">
	<tr>
		<th>ID</th>
		<th>Titulo</th>
		<th>Conteudo</th>
		<th>Criado em</th>
		<th>Atualizado em</th>
		<th>Nome da imagem</th>
		<th>Tipo da imagem</th>
		<th>Tamanho</th>
		<th>Imagem atualizada em</th>
	</tr>

	<% @posts.each do |post| %>
	  <tr>
		<td><%= post.id %></td>
		<td><%= post.title %></td>
		<td><%= post.body %></td>
		<td><%= post.created_at %></td>
		<td><%= post.updated_at %></td>
		<td><%= post.avatar_file_name %></td>
		<td><%= post.avatar_content_type %></td>
		<td><%= post.avatar_file_size %></td>
		<td><%= post.avatar_updated_at %></td>		
	  </tr>
	<% end %>

</table>

app/views/posts/new.html.erb
<%- model_class = Post -%>
<div class="page-header">
  <h1><%=t '.title', :default => [:'helpers.titles.new', 'New %{model}'], :model => model_class.model_name.human.titleize %></h1>
</div>
<%= render :partial => 'form' %>

app/views/posts/show.html.erb
<div id="all">
<div class="thumbnail" id="post_content">
  <h1 class="title"><%= @post.title %></h1> 
  <p class="body"><%= @post.body %></p><br>
  <p class="date">Submitted <%= time_ago_in_words(@post.created_at) %></p>
  <p class="img"><%= image_tag @post.avatar.url(:thumb) %></p><br>
    <% if user_signed_in? %>
      <% if current_user.admin? %>  
      <%= link_to t('.back', :default => t("helpers.links.back")),
        posts_path, :class => 'btn btn-default'  %>
      <%= link_to t('.edit', :default => t("helpers.links.edit")),
        edit_post_path(@post), :class => 'btn btn-default' %>
      <%= link_to t('.destroy', :default => t("helpers.links.destroy")), post_path(@post, type: :normal), :method => 'delete',
              :data => { :confirm => t('.confirm', :default => t("helpers.links.confirm", :default => 'Are you sure?')) }, :class => 'btn btn-danger' %>
      <% end %>
    <% end %>
</div>

<div>
  <div class="thumbnail" id="comments">
    <h2><%= @post.comments.count %> Comments</h2>
    <%= render @post.comments %>

    
  </div>
</div>

<div class="add_comments">
      <h3>Add a comment:</h3>
      <%= render "comments/form" %>
    </div>

</div>


<br><br><br><br>

<h3><%= link_to '<== Home', root_path %></h3>

app/views/user/index.html.erb
<h1>Listing users</h1>


<table class="table table-striped">
  <thead>
    <tr>
        
      <th>Email</th>
    
      <th>Email</th>

    </tr>
  </thead>
  <tbody>
    <% @users.each do |user| %>
      <tr>        
        <td><%= user.email %></td>
        <td><%= user.role %></td>   
      </tr>
    <% end %>
  </tbody>
</table>

app/views/users/shared/_links.html.erb
<%- if controller_name != 'sessions' %>
  <%= link_to "Log in", new_session_path(resource_name), :class => 'btn btn-default'  %><br />
<% end -%>

<%- if devise_mapping.registerable? && controller_name != 'registrations' %>
  <%= link_to "Sign up", new_registration_path(resource_name), :class => 'btn btn-default'  %><br />
<% end -%>

<%- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations' %>
  <%= link_to "Forgot your password?", new_password_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.confirmable? && controller_name != 'confirmations' %>
  <%= link_to "Didn't receive confirmation instructions?", new_confirmation_path(resource_name), :class => 'btn btn-default'  %><br />
<% end -%>

<%- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks' %>
  <%= link_to "Didn't receive unlock instructions?", new_unlock_path(resource_name), :class => 'btn btn-default'  %><br />
<% end -%>

<%- if devise_mapping.omniauthable? %>
  <%- resource_class.omniauth_providers.each do |provider| %>
    <%= link_to "Sign in with #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider), :class => 'btn btn-default'  %><br />
  <% end -%>
<% end -%>